<?php
/**
 * Pizza Parlor functions and definitions
 *
 * @package Pizza Parlor
 */

if ( ! defined( 'PIZZA_PARLOR_VERSION' ) ) {
	// Replace the version number of the theme on each release.
	define( 'PIZZA_PARLOR_VERSION', '1.0.0' );
}

function pizza_parlor_setup() {

	load_theme_textdomain( 'pizza-parlor', get_template_directory() . '/languages' );
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'title-tag' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'woocommerce' );
	add_theme_support( "align-wide" );
	add_theme_support( "responsive-embeds" );

	register_nav_menus(
		array(
			'menu-1' => esc_html__( 'Primary', 'pizza-parlor' ),
			'social-menu' => esc_html__('Staff Social Menu', 'pizza-parlor'),
			'social-menu-1' => esc_html__('Staff Social Menu 1', 'pizza-parlor'),
			'social-menu-2' => esc_html__('Staff Social Menu 2', 'pizza-parlor'),
			'social-menu-3' => esc_html__('Staff Social Menu 3', 'pizza-parlor'),
		)
	);

	add_theme_support(
		'html5',
		array(
			'search-form',
			'comment-form',
			'comment-list',
			'gallery',
			'caption',
			'style',
			'script',
		)
	);

	add_theme_support(
		'custom-background',
		apply_filters(
			'pizza_parlor_custom_background_args',
			array(
				'default-color' => '#fafafa',
				'default-image' => '',
			)
		)
	);

	add_theme_support( 'customize-selective-refresh-widgets' );

	add_theme_support(
		'custom-logo',
		array(
			'height'      => 250,
			'width'       => 250,
			'flex-width'  => true,
			'flex-height' => true,
		)
	);
	
	add_theme_support( 'post-formats', array(
        'image',
        'video',
        'gallery',
        'audio', 
    ));

}
add_action( 'after_setup_theme', 'pizza_parlor_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $pizza_parlor_content_width
 */
function pizza_parlor_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'pizza_parlor_content_width', 640 );
}
add_action( 'after_setup_theme', 'pizza_parlor_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function pizza_parlor_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'pizza-parlor' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'pizza-parlor' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 1', 'pizza-parlor' ),
			'id'            => 'footer-1',
			'description'   => esc_html__( 'Add widgets here.', 'pizza-parlor' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 2', 'pizza-parlor' ),
			'id'            => 'footer-2',
			'description'   => esc_html__( 'Add widgets here.', 'pizza-parlor' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 3', 'pizza-parlor' ),
			'id'            => 'footer-3',
			'description'   => esc_html__( 'Add widgets here.', 'pizza-parlor' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);
}
add_action( 'widgets_init', 'pizza_parlor_widgets_init' );


function pizza_parlor_social_menu() {
    if (has_nav_menu('social-menu')) :
        wp_nav_menu(array(
            'theme_location' => 'social-menu',
            'container' => 'ul',
            'menu_class' => 'social-menu menu',
            'menu_id'  => 'menu-social',
        ));
    endif;
}


function pizza_parlor_social_menu_1() {
    if (has_nav_menu('social-menu-1')) :
        wp_nav_menu(array(
            'theme_location' => 'social-menu-1',
            'container' => 'ul',
            'menu_class' => 'social-menu menu',
            'menu_id'  => 'menu-social',
        ));
    endif;
}

function pizza_parlor_social_menu_2() {
    if (has_nav_menu('social-menu-2')) :
        wp_nav_menu(array(
            'theme_location' => 'social-menu-2',
            'container' => 'ul',
            'menu_class' => 'social-menu menu',
            'menu_id'  => 'menu-social-2',
        ));
    endif;
}

function pizza_parlor_social_menu_3() {
    if (has_nav_menu('social-menu-3')) :
        wp_nav_menu(array(
            'theme_location' => 'social-menu-3',
            'container' => 'ul',
            'menu_class' => 'social-menu menu',
            'menu_id'  => 'menu-social-3',
        ));
    endif;
}

/**
 * Enqueue scripts and styles.
 */
function pizza_parlor_scripts() {

	// Load fonts locally
	require_once get_theme_file_path('revolution/inc/wptt-webfont-loader.php');

	$pizza_parlor_font_families = array(
		'Hurricane',
		'Inter:wght@100..900',
		'Bree+Serif',
	);
	
	$pizza_parlor_fonts_url = add_query_arg( array(
		'family' => implode( '&family=', $pizza_parlor_font_families ),
		'display' => 'swap',
	), 'https://fonts.googleapis.com/css2' );

	wp_enqueue_style('pizza-parlor-google-fonts', wptt_get_webfont_url(esc_url_raw($pizza_parlor_fonts_url)), array(), '1.0.0');
	
	// Font Awesome CSS
    wp_enqueue_style('font-awesome-6', get_template_directory_uri() . '/revolution/assets/vendors/font-awesome-6/css/all.min.css', array(), '6.7.2');

	wp_enqueue_style('owl.carousel.style', get_template_directory_uri() . '/revolution/assets/css/owl.carousel.css', array());
	
	wp_enqueue_style( 'pizza-parlor-style', get_stylesheet_uri(), array(), PIZZA_PARLOR_VERSION );

	// Add custom inline styles
	require get_parent_theme_file_path('/custom-style.php');
	wp_add_inline_style('pizza-parlor-style', $pizza_parlor_custom_css);

	wp_style_add_data('pizza-parlor-style', 'rtl', 'replace');

	wp_enqueue_script( 'pizza-parlor-navigation', get_template_directory_uri() . '/js/navigation.js', array(), PIZZA_PARLOR_VERSION, true );

	require get_parent_theme_file_path( '/custom-style.php' );
	wp_add_inline_style( 'pizza-parlor-style',$pizza_parlor_custom_css );

	wp_enqueue_script( 'owl.carousel.jquery', get_template_directory_uri() . '/revolution/assets/js/owl.carousel.js', array(), PIZZA_PARLOR_VERSION, true );

	wp_enqueue_script( 'pizza-parlor-custom-js', get_template_directory_uri() . '/revolution/assets/js/custom.js', array('jquery'), PIZZA_PARLOR_VERSION, true );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}
}
add_action( 'wp_enqueue_scripts', 'pizza_parlor_scripts' );

if (!function_exists('pizza_parlor_related_post')) :
    /**
     * Display related posts from same category
     *
     */

    function pizza_parlor_related_post($post_id){        
        $pizza_parlor_categories = get_the_category($post_id);
        if ($pizza_parlor_categories) {
            $pizza_parlor_category_ids = array();
            $pizza_parlor_category = get_category($pizza_parlor_category_ids);
            $pizza_parlor_categories = get_the_category($post_id);
            foreach ($pizza_parlor_categories as $pizza_parlor_category) {
                $pizza_parlor_category_ids[] = $pizza_parlor_category->term_id;
            }
            $count = $pizza_parlor_category->category_count;
            if ($count > 1) { ?>

         	<?php
		$pizza_parlor_related_post_wrap = absint(get_theme_mod('pizza_parlor_enable_related_post', 1));
		if($pizza_parlor_related_post_wrap == 1){ ?>
                <div class="related-post">
                    
                    <h2 class="post-title"><?php esc_html_e(get_theme_mod('pizza_parlor_related_post_text', __('Related Post', 'pizza-parlor'))); ?></h2>
                    <?php
                    $pizza_parlor_cat_post_args = array(
                        'category__in' => $pizza_parlor_category_ids,
                        'post__not_in' => array($post_id),
                        'post_type' => 'post',
                        'posts_per_page' =>  get_theme_mod( 'pizza_parlor_related_post_count', '3' ),
                        'post_status' => 'publish',
						'orderby'           => 'rand',
                        'ignore_sticky_posts' => true
                    );
                    $pizza_parlor_featured_query = new WP_Query($pizza_parlor_cat_post_args);
                    ?>
                    <div class="rel-post-wrap">
                        <?php
                        if ($pizza_parlor_featured_query->have_posts()) :

                        while ($pizza_parlor_featured_query->have_posts()) : $pizza_parlor_featured_query->the_post();
                            ?>

							<div class="card-item rel-card-item">
								<div class="card-content">
                                    <?php if ( has_post_thumbnail() ) { ?>
                                        <div class="card-media">
                                            <?php pizza_parlor_post_thumbnail(); ?>
                                        </div>
                                    <?php } else {
                                        // Fallback default image
                                        $pizza_parlor_default_post_thumbnail = get_template_directory_uri() . '/revolution/assets/images/chef2.png';
                                        echo '<img class="default-post-img" src="' . esc_url( $pizza_parlor_default_post_thumbnail ) . '" alt="' . esc_attr( get_the_title() ) . '">';
                                    } ?>
									<div class="entry-title">
										<h3>
											<a href="<?php the_permalink() ?>">
												<?php the_title(); ?>
											</a>
										</h3>
									</div>
									<div class="entry-meta">
                                        <?php
                                        pizza_parlor_posted_on();
                                        pizza_parlor_posted_by();
                                        ?>
                                    </div>
								</div>
							</div>
                        <?php
                        endwhile;
                        ?>
                <?php
                endif;
                wp_reset_postdata();
                ?>
                </div>
                <?php } ?>
                <?php
            }
        }
    }
endif;
add_action('pizza_parlor_related_posts', 'pizza_parlor_related_post', 10, 1);

function pizza_parlor_sanitize_choices( $pizza_parlor_input, $pizza_parlor_setting ) {
    global $wp_customize; 
    $pizza_parlor_control = $wp_customize->get_control( $pizza_parlor_setting->id ); 
    if ( array_key_exists( $pizza_parlor_input, $pizza_parlor_control->choices ) ) {
        return $pizza_parlor_input;
    } else {
        return $pizza_parlor_setting->default;
    }
}

//Excerpt 
function pizza_parlor_excerpt_function($pizza_parlor_excerpt_count = 35) {
    $pizza_parlor_excerpt = get_the_excerpt();
    $pizza_parlor_text_excerpt = wp_strip_all_tags($pizza_parlor_excerpt);
    $pizza_parlor_excerpt_limit = (int) get_theme_mod('pizza_parlor_excerpt_limit', $pizza_parlor_excerpt_count);
    $pizza_parlor_words = preg_split('/\s+/', $pizza_parlor_text_excerpt); 
    $tpizza_parlor_rimmed_words = array_slice($pizza_parlor_words, 0, $pizza_parlor_excerpt_limit);
    $pizza_parlor_theme_excerpt = implode(' ', $tpizza_parlor_rimmed_words);

    return $pizza_parlor_theme_excerpt;
}

// Add admin notice
function pizza_parlor_admin_notice() { 
    global $pagenow;
    $pizza_parlor_theme_args      = wp_get_theme();
    $pizza_parlor_meta            = get_option( 'pizza_parlor_admin_notice' );
    $name            = $pizza_parlor_theme_args->__get( 'Name' );
    $pizza_parlor_current_screen  = get_current_screen();

    if( !$pizza_parlor_meta ){
	    if( is_network_admin() ){
	        return;
	    }

	    if( ! current_user_can( 'manage_options' ) ){
	        return;
	    } 
		
		if( $pizza_parlor_current_screen->base !== 'appearance_page_pizza_parlor_guide' && 
            $pizza_parlor_current_screen->base !== 'toplevel_page_pizzaparlor-demoimport' ) { ?>

            <div class="notice notice-success pizza-parlor-welcome-notice">
                <p class="pizza-parlor-dismiss-link">
                    <strong>
                        <a href="<?php echo esc_url( add_query_arg( 'pizza_parlor_admin_notice', '1' ) ); ?>">
                            <?php esc_html_e( 'Dismiss', 'pizza-parlor' ); ?>
                        </a>
                    </strong>
                </p>

                <div class="pizza-parlor-welcome-notice-wrap">
                    <h2 class="pizza-parlor-notice-title">
                        <span class="dashicons dashicons-admin-home"></span> 
                        <?php 
                            $pizza_parlor_theme_name = wp_get_theme()->get( 'Name' );
                            /* translators: %s!: Theme Name. */
                            echo esc_html( sprintf( __( 'Welcome to the free theme: %s!', 'pizza-parlor' ), $pizza_parlor_theme_name ) );
                        ?>
                    </h2>
                    <p class="pizza-parlor-notice-desc">
                        <?php esc_html_e( 'Get started by exploring the features of your new theme. Customize your design, add your content, and create a site that fits your vision.', 'pizza-parlor' ); ?>
                    </p>

                    <div class="pizza-parlor-welcome-info">
                        <div class="pizza-parlor-welcome-thumb">
                            <img src="<?php echo esc_url( get_stylesheet_directory_uri() . '/screenshot.png' ); ?>" alt="<?php esc_attr_e( 'Theme Screenshot', 'pizza-parlor' ); ?>">
                        </div>

                        <div class="pizza-parlor-welcome-import">
                            <h3><span class="dashicons dashicons-download"></span> <?php esc_html_e( 'Quick Start: Import Demo', 'pizza-parlor' ); ?></h3>
                            <p><?php esc_html_e( 'Use the Demo Importer to quickly set up your site with a pre-made layout. Get a complete site in minutes.', 'pizza-parlor' ); ?></p>
                            <p><a class="button info-link button-primary" href="<?php echo esc_url( admin_url( 'themes.php?page=pizzaparlor-demoimport' ) ); ?>"><?php esc_html_e( 'Go to Demo Importer', 'pizza-parlor' ); ?></a></p>
                        </div>

                        <div class="pizza-parlor-welcome-getting-started">
                            <h3><span class="dashicons dashicons-art"></span> <?php esc_html_e( 'Customize Your Theme', 'pizza-parlor' ); ?></h3>
                            <p><?php esc_html_e( 'Want to make it truly yours? Explore the Getting Started Guide to personalize your site to suit your needs.', 'pizza-parlor' ); ?></p>
                            <p><a class="info-link button" href="<?php echo esc_url( admin_url( 'themes.php?page=pizza-parlor-getstart-page' ) ); ?>"><?php esc_html_e( 'View Getting Started Guide', 'pizza-parlor' ); ?></a></p>
                        </div>
                    </div>
                </div>
            </div>

            <?php
        }
	}
}

add_action( 'admin_notices', 'pizza_parlor_admin_notice' );

if( ! function_exists( 'pizza_parlor_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
*/
function pizza_parlor_update_admin_notice(){
    if ( isset( $_GET['pizza_parlor_admin_notice'] ) && $_GET['pizza_parlor_admin_notice'] = '1' ) {
        update_option( 'pizza_parlor_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'pizza_parlor_update_admin_notice' );


add_action('after_switch_theme', 'pizza_parlor_setup_options');
function pizza_parlor_setup_options () {
    update_option('pizza_parlor_admin_notice', FALSE );
}

/**
 * Checkbox sanitization callback example.
 *
 * Sanitization callback for 'checkbox' type controls. This callback sanitizes `$pizza_parlor_checked`
 * as a boolean value, either TRUE or FALSE.
 */
function pizza_parlor_sanitize_checkbox($pizza_parlor_checked)
{
    // Boolean check.
    return ((isset($pizza_parlor_checked) && true == $pizza_parlor_checked) ? true : false);
}

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/revolution/inc/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/revolution/inc/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/revolution/inc/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/revolution/inc/customizer.php';

/**
 * Breadcrumb File.
 */
require get_template_directory() . '/revolution/inc/breadcrumbs.php';

/**
 * Custom typography options for this theme.
 */
require get_template_directory() . '/revolution/inc/typography-options.php';

//////////////////////////////////////////////   Function for Translation Error   //////////////////////////////////////////////////////
function pizza_parlor_enqueue_function() {

	/**
	* GET START.
	*/
	require get_template_directory() . '/getstarted/pizza_parlor_about_page.php';

	/**
	* DEMO IMPORT.
	*/
	require get_template_directory() . '/demo-import/pizza_parlor_config_file.php';

	define('PIZZA_PARLOR_FREE_SUPPORT',__('https://wordpress.org/support/theme/pizza-parlor/','pizza-parlor'));
	define('PIZZA_PARLOR_PRO_SUPPORT',__('https://www.revolutionwp.com/pages/community/','pizza-parlor'));
	define('PIZZA_PARLOR_REVIEW',__('https://wordpress.org/support/theme/pizza-parlor/reviews/#new-post','pizza-parlor'));
	define('PIZZA_PARLOR_BUY_NOW',__('https://www.revolutionwp.com/products/pizza-wordpress-theme','pizza-parlor'));
	define('PIZZA_PARLOR_LIVE_DEMO',__('https://demo.revolutionwp.com/pizza-parlor-pro/','pizza-parlor'));
	define('PIZZA_PARLOR_PRO_DOC',__('https://demo.revolutionwp.com/wpdocs/pizza-parlor-pro/','pizza-parlor'));
	define('PIZZA_PARLOR_LITE_DOC',__('https://demo.revolutionwp.com/wpdocs/pizza-parlor-free','pizza-parlor'));
	
}
add_action( 'after_setup_theme', 'pizza_parlor_enqueue_function' );


/**
 * Load Jetpack compatibility file.
 */
if ( defined( 'JETPACK__VERSION' ) ) {
	require get_template_directory() . '/revolution/inc/jetpack.php';
}


function pizza_parlor_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'pizza_parlor_remove_customize_register', 11 );


/**
 * WooCommerce custom filters
 */
add_filter('loop_shop_columns', 'pizza_parlor_loop_columns');

if (!function_exists('pizza_parlor_loop_columns')) {

	function pizza_parlor_loop_columns() {

		$pizza_parlor_columns = get_theme_mod( 'pizza_parlor_per_columns', 3 );

		return $pizza_parlor_columns;
	}
}

/************************************************************************************/

add_filter( 'loop_shop_per_page', 'pizza_parlor_per_page', 20 );

function pizza_parlor_per_page( $pizza_parlor_cols ) {

  	$pizza_parlor_cols = get_theme_mod( 'pizza_parlor_product_per_page', 9 );

	return $pizza_parlor_cols;
}

/************************************************************************************/

add_filter( 'woocommerce_output_related_products_args', 'pizza_parlor_products_args' );

function pizza_parlor_products_args( $pizza_parlor_args ) {

    $pizza_parlor_args['posts_per_page'] = get_theme_mod( 'custom_related_products_number', 6 );

    $pizza_parlor_args['columns'] = get_theme_mod( 'custom_related_products_number_per_row', 3 );

    return $pizza_parlor_args;
}

/************************************************************************************/

// Function to output custom CSS directly in the head section
function pizza_parlor_add_custom_css() {
    // Retrieve the slider visibility setting
    $pizza_parlor_slider_enabled = get_theme_mod('pizza_parlor_enable_slider', true);
    
    // Check if the slider is not enabled
    if (!$pizza_parlor_slider_enabled) {
        echo '<style type="text/css">
            .page-template-revolution-home .main-nav-wrap {
                position: static;
                background: #ccc;
            }
        </style>';
    }
}

// Hook the function into the wp_head action
add_action('wp_head', 'pizza_parlor_add_custom_css');


/************************************************************************************/

/**
 * Custom logo
 */

function pizza_parlor_custom_css() {
?>
	<style type="text/css" id="custom-theme-colors" >
        :root {
           
            --pizza_parlor_logo_width: <?php echo absint(get_theme_mod('pizza_parlor_logo_width')); ?> ;   
        }
        .site-branding img {
            max-width:<?php echo esc_html(get_theme_mod('pizza_parlor_logo_width')); ?>px ;    
        }         
	</style>
<?php
}
add_action( 'wp_head', 'pizza_parlor_custom_css' );

function get_changelog_from_readme() {
    $pizza_parlor_file_path = get_template_directory() . '/readme.txt'; // Adjust path if necessary

    if (file_exists($pizza_parlor_file_path)) {
        $pizza_parlor_content = file_get_contents($pizza_parlor_file_path);

        // Extract changelog section
        $pizza_parlor_changelog_start = strpos($pizza_parlor_content, "== Changelog ==");
        $pizza_parlor_changelog = substr($pizza_parlor_content, $pizza_parlor_changelog_start);

        // Split changelog into versions
        preg_match_all('/\*\s([\d\.]+)\s-\s(.+?)\n((?:\t-\s.+?\n)+)/', $pizza_parlor_changelog, $pizza_parlor_matches, PREG_SET_ORDER);
        
        return $pizza_parlor_matches;
    }
    return [];
}